var LOGFILE_NAME = "app-myenersave.log";
var l = new Logger(LOGFILE_NAME);

function addLeadingZeroes(number, count)
{
    var result = number + '';
    while (result.length < count) 
    {
        result = '0' + result;
    }
    return result;
}

function createFullPOSTString(token, meterValueString)
{
    var result = 'POST /fetcher/data HTTP/1.1\r\n';
    result += 'token: ' + token + '\r\n';
    result += 'Connection: Close\r\n';
    result += 'Content-Type: application/xml\r\n';
    result += 'User-Agent: dSS metering\r\n';
    result += 'Host: data.myenersave.com:80\r\n';
    result += 'Accept: text/html, image/gif, jpeg, *; q=.2, */*; q=.2\r\n';
    
    
    var content = '<upload>\r\n'
    content += meterValueString;
    content += '</upload>\r\n';
    
    result += 'Content-Length: ' + content.length;
    result += '\r\n\r\n';
    result += content + '\r\n';

    l.logln('------------');
    l.logln(result);
    l.logln('------------');
    
    return result;
}

function getNeededDSMs()
{
	var oReturnMeters=[]
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		l.logln("Check "+oMeter.dsid);
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")!=null)
		{
			if (Property.getProperty("dSM/" + oMeter.dsid + "/enabled")) {
				oReturnMeters.push(oMeter);
				l.logln("Accept "+oMeter.dsid);
			}
		}
	}
	return oReturnMeters;
}


function sendMeterData() {
	l.logln("SendData");
	var apikey=Property.getProperty("apiKey");
	if  ((apikey==null) || (apikey==""))
	{
		l.logln("Keine Logindaten vorhanden");
		return;
	} 
	
	var Meters=getNeededDSMs();
	var meterDSID=[];
	var minResolution=-1;
	var oSeries=Metering.getResolutions();
	for (var index in oSeries)
	{
		var object=oSeries[index];
		if (object.type=="energy") 
			if (minResolution==-1)
				minResolution=object.resolution;
			else 
				if (minResolution>object.resolution)
					minResolution=object.resolution;
		
	}
	if (minResolution==-1)
		l.logln("Konnte kleinste Auflsung nicht bestimmen");
	
	
	var content="";
	
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		var presentString="/apartment/dSMeters/" + oMeter.dsid +"/present"
		if (Property.getProperty(presentString)) {
			l.logln("Check "+oMeter.dsid);
			var oValues=Metering.getValues(oMeter.dsid,"energy",minResolution);

            content += '  <sensor id="'+oMeter.dsid+'" type="10" description="' + oMeter.name + '">\r\n';

			
			var iBackcastMax=4;
			for (var iBackcast=iBackcastMax;iBackcast>=0;iBackcast--) {
				var sValue=oValues[iBackcast];
				if (sValue!=null) {
					l.logln("Wert: " + sValue.timestamp + " " + sValue.value);
					var year=parseInt(sValue.timestamp.substring(0,4),10);
					var mont=parseInt(sValue.timestamp.substring(5,7),10);
					mont-=1;
					var day=parseInt(sValue.timestamp.substring(8,10),10);
					var hour=parseInt(sValue.timestamp.substring(11,13),10);
					var minute=parseInt(sValue.timestamp.substring(14,16),10);
					var second=parseInt(sValue.timestamp.substring(17,19),10);
					
					var utz=new Date(year,mont,day,hour,minute,second,0);
					var utzVal=Math.floor(utz.getTime() / 1000); //(utz.getTimezoneOffset()*60)+
					
		            content += '   <energy time="'
		                + utzVal
		                + '" reg="'+ sValue.value + '.0"/>\r\n';
				}
			}
            content += '  </sensor>\r\n';			
		}				
	}
	
	var req= createFullPOSTString(apikey, content);
	
	var socket = new TcpSocket();
    function onConnect(state, postString)
    {
        if (state) 
        {
            l.logln("Connected");
            socket.send(postString, function(bytesSent)
            {
                socket.receiveLine(128, function(data) {
                    l.logln("data received: " + data);
                    socket.close();
                });
            });
        }
        else 
        {
            l.logln("Connection failed");
        }
    }
    
    socket.connect('data.myenersave.com', 80, function(state)
    {
        onConnect(state, req);
    });

}

function prepare()
{
	if (raisedEvent.parameter.apikey==null)
		return;
	var prop = new Property('apiKey');
	prop.setValue(raisedEvent.parameter.apikey);
	prop.setFlag('ARCHIVE', true);
	
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")==null)
		{
			var prop = new Property("dSM/" + oMeter.dsid + "/dSID");
			prop.setValue(oMeter.dsid);
			prop.setFlag('ARCHIVE', true);
			prop = new Property("dSM/" + oMeter.dsid + "/enabled");
			prop.setValue(true);
			prop.setFlag('ARCHIVE', true);
		}
	}
	
	Property.store();
	sendMeterData();
}


function main() {
	if (raisedEvent.name === "running") {
		Property.load();
	}
	else if (raisedEvent.name === "myenersave") {
		if (raisedEvent.parameter.actions) {
			l.logln('Execute: ' + raisedEvent.name + ' '+raisedEvent.parameter.actions);
			if (raisedEvent.parameter.actions == 'load')
				Property.load();
			if (raisedEvent.parameter.actions == 'save')
				Property.store();
			if (raisedEvent.parameter.actions == 'sendMeterData')
				sendMeterData();
			if (raisedEvent.parameter.actions == 'prepare')
				prepare();
		}

	}	
}

main();